#LyX 1.3 created this file. For more info see http://www.lyx.org/
\lyxformat 221
\textclass article
\begin_preamble
\include{style}
\end_preamble
\language english
\inputencoding auto
\fontscheme pslatex
\graphics default
\paperfontsize 10
\spacing single 
\papersize a4paper
\paperpackage a4
\use_geometry 0
\use_amsmath 0
\use_natbib 0
\use_numerical_citations 0
\paperorientation portrait
\secnumdepth 3
\tocdepth 3
\paragraph_separation indent
\defskip medskip
\quotes_language english
\quotes_times 2
\papercolumns 1
\papersides 1
\paperpagestyle default

\layout Title

Semester project:
\newline 
Networked I/O with rollback in JNuke
\layout Date

September 3, 2004
\newline 
(project runs from October 18 until February 5)
\layout Author

Cyrille Artho (project assigned to Boris Zweimüller)
\layout Abstract

JNuke supports file I/O in its current implementation, but not networked
 I/O.
 Most interesting multi-threaded programs use sockets, so this limitation
 is quite severe for running applications on JNuke.
 The goal of this project is to support network operations and implement
 an I/O layer that can transparently replay a network communication to the
 Java application, and also detect when such a replay is no longer possible.
\layout Section

Concept
\layout Standard

In this phase, the question of how to support rollback for file and networked
 I/O should be answered.
\layout Description

Goal: Problem description and specification of solution.
\layout Description

Deliverables: Short document.
\layout Description

Time: November 2.
\layout Section

Networked I/O without rollback, file I/O with rollback, networked I/O with
 rollback
\layout Standard

Implementation of the needed functionality in several steps (milestones).
\layout Description

Goal: 1) Socket support; 2) rollback for files (read/write/append, create/delete
 etc.); 3) networking with rollback.
\layout Description

Time: 1) November 9; 2) December; 3) January 7.
\layout Section

Experiments, report
\layout Standard

In the final four weeks, the goal is to take advantage of the new functionality,
 which will allow running existing analysis programs on a much larger set
 of benchmarks.
 A short technical report should summarize work done in this project and
 results of experiments.
\the_end
